Status: Resolved Priority: Should have
Author: Christian Müller Category: Security
Created: 2013-03-05 Assigned To: Christian Müller
Updated: 2013-10-03 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: (any)
Subject: AuthenticationRequired should not be thrown in PolicyEnforcement if resource is available to Everybody
Description

In case you define a (method) resource (in my case with runtime argument condition) and you GRANT access to this resource for the
"Everybody" role you will still end up with an AuthenticationRequiredException (or if defined a redirect to the WebRedirect) because
the AuthenticationManager will throw that on not logged in BEFORE the AccessDecisionManager checks the actual permissions for
the resource.

To fix this we need to temporarily catch the exception when there were no tokens to be authenticated and check permissions on the
AccessDecisionManager. If this then throws an AccessDeniedException we know the resource was inaccessible for not logged in
user (at least with the current runtime evaluation) and we should probably trigger a redirect to the WebRedirect. In case the
AccessDecisionManager granted access to the resource we can proceed as obviously the resource was meant to be available
without login.

Associated revisions
Revision 1efc1016 - 2013-05-17 17:09 - Christian Müller

[BUGFIX] Allow access to resources GRANTED to "Everybody"

PolicyEnforcement does no longer throw an AccessDenied exception
if not logged in before checking the actual ACLs for the
resource in question. This allows creating resources and
granting access to them for "Everybody" which was not possible
before.

Fixes: #46036
Releases: master, 2.0
Change-Id: I6aa50f69ef3284e59933c89a9f8bfee08ac1b800

Revision b6768ccf - 2013-10-02 10:15 - Christian Müller

[BUGFIX] Allow access to resources GRANTED to "Everybody"

PolicyEnforcement does no longer throw an AccessDenied exception
if not logged in before checking the actual ACLs for the
resource in question. This allows creating resources and
granting access to them for "Everybody" which was not possible
before.

Fixes: #46036
Releases: master, 2.0
Change-Id: I6aa50f69ef3284e59933c89a9f8bfee08ac1b800

History
#1 - 2013-03-05 11:41 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18695

#2 - 2013-03-05 11:43 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18695

#3 - 2013-03-05 14:37 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18695

#4 - 2013-03-05 14:38 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18695

#5 - 2013-03-05 14:41 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18695

#6 - 2013-03-05 14:59 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18695

#7 - 2013-05-17 17:10 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18695

#8 - 2013-08-14 15:35 - Karsten Dambekalns
- Target version changed from 2.0 to 2.0.1

#9 - 2013-10-02 10:15 - Gerrit Code Review
Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/24240

#10 - 2013-10-03 19:35 - Christian Müller
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:b6768ccfb736ef8b536f420cd2d8068edc44267b.
